diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/utils.c leptonlib-1.066/src/utils.c
--- leptonlib-1.66/src/utils.c	2010-08-08 03:29:17.000000000 +0300
+++ leptonlib-1.066/src/utils.c	2010-09-16 08:14:02.000000000 +0300
@@ -91,6 +91,9 @@
  *           char      *mungePathnameForWindows()
  *           l_int32    extractNumberFromFilename()
  *
+ *       Generate random integer in given range
+ *           l_int32    genRandomIntegerInRange()
+ *
  *       Version number
  *           char      *getLeptonlibVersion()
  *           char      *getImagelibVersions()
@@ -1345,6 +1348,7 @@
 arrayReadStream(FILE     *fp, 
                 l_int32  *pnbytes)
 {
+l_int32   ignore;
 l_uint8  *data;
 
     PROCNAME("arrayReadStream");
@@ -1358,7 +1362,7 @@
     *pnbytes = fnbytesInFile(fp);
     if ((data = (l_uint8 *)CALLOC(1, *pnbytes + 1)) == NULL)
         return (l_uint8 *)ERROR_PTR("CALLOC fail for data", procName, NULL);
-    fread(data, *pnbytes, 1, fp);
+    ignore = fread(data, 1, *pnbytes, fp);
     return data;
 }
 
@@ -2063,6 +2067,41 @@
 }
 
 
+/*---------------------------------------------------------------------*
+ *                Generate random integer in given range               *
+ *---------------------------------------------------------------------*/
+/*!
+ *  genRandomIntegerInRange()
+ *
+ *      Input:  range (size of range; must be >= 2)
+ *              seed (use 0 to skip; otherwise call srand)
+ *              val (<return> random integer in range {0 ... range-1}
+ *      Return: 0 if OK, 1 on error
+ *
+ *  Notes:
+ *      (1) For example, to choose a rand integer between 0 and 99,
+ *          use @range = 100.
+ */
+l_int32
+genRandomIntegerInRange(l_int32   range,
+                        l_int32   seed,
+                        l_int32  *pval)
+{
+    PROCNAME("genRandomIntegerInRange");
+
+    if (!pval)
+        return ERROR_INT("&val not defined", procName, 1);
+    *pval = 0;
+    if (range < 2)
+        return ERROR_INT("range must be >= 2", procName, 1);
+
+    if (seed > 0) srand(seed);
+    *pval = (l_int32)((l_float64)range *
+                       ((l_float64)rand() / (l_float64)RAND_MAX));
+    return 0;
+}
+
+
 /*---------------------------------------------------------------------*
  *                          Version number                             *
  *---------------------------------------------------------------------*/
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/viewfiles.c leptonlib-1.066/src/viewfiles.c
--- leptonlib-1.66/src/viewfiles.c	2009-07-25 20:22:47.000000000 +0300
+++ leptonlib-1.066/src/viewfiles.c	2010-09-16 08:20:32.000000000 +0300
@@ -76,7 +76,7 @@
 char       charbuf[L_BUF_SIZE];
 char       htmlstring[] = "<html>";
 char       framestring[] = "</frameset></html>";
-l_int32    i, nfiles, index, w, nimages;
+l_int32    i, nfiles, index, w, nimages, ignore;
 l_float32  factor;
 PIX       *pix, *pixthumb, *pixview;
 SARRAY    *safiles, *sathumbs, *saviews, *sahtml, *salink;
@@ -105,7 +105,7 @@
 
         /* Make the output directory if it doesn't already exist */
     sprintf(charbuf, "mkdir -p %s", dirout);
-    system(charbuf);
+    ignore = system(charbuf);
 
         /* Capture the filenames in the input directory */
     if ((safiles = getFilenamesInDirectory(dirin)) == NULL)
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/webpimg.h leptonlib-1.066/src/webpimg.h
--- leptonlib-1.66/src/webpimg.h	1970-01-01 02:00:00.000000000 +0200
+++ leptonlib-1.066/src/webpimg.h	2010-09-29 21:19:39.000000000 +0300
@@ -0,0 +1,181 @@
+/*===========================================================================*
+ - Copyright 2010 Google Inc.
+ -
+ - This code is licensed under the same terms as WebM:
+ - Software License Agreement:  http://www.webmproject.org/license/software/
+ - Additional IP Rights Grant:  http://www.webmproject.org/license/additional/
+ *===========================================================================*/
+
+/*
+ * Encoding/Decoding of WebP still image compression format.
+ *
+ * 1. WebPDecode: Takes an array of bytes (string) corresponding to the WebP
+ *                encoded image and generates output in the YUV format with
+ *                the color components U, V subsampled to 1/2 resolution along
+ *                each dimension.
+ *
+ * 2. YUV420toRGBA: Converts from YUV (with color subsampling) such as produced
+ *                  by the WebPDecode routine into 32 bits per pixel RGBA data
+ *                  array. This data array can be directly used by the Leptonica
+ *                  Pix in-memory image format.
+ *
+ * 3. WebPEncode: Takes a Y, U, V data buffers (with color components U and V
+ *                subsampled to 1/2 resolution) and generates the WebP string
+ *
+ * 4. RGBAToYUV420: Generates Y, U, V data (with color subsampling) from 32 bits
+ *                  per pixel RGBA data buffer. The resulting YUV data can be
+ *                  directly fed into the WebPEncode routine.
+ *
+ * 5. AdjustColorspace:
+ *
+ * 6. AdjustColorspaceBack:
+ */
+
+#ifndef THIRD_PARTY_VP8_VP8IMG_H_
+#define THIRD_PARTY_VP8_VP8IMG_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif  /* __cplusplus */
+
+typedef unsigned char uint8;
+typedef unsigned int uint32;
+typedef enum WebPResultType {
+  webp_success = 0,
+  webp_failure = -1
+} WebPResult;
+
+/* Takes an array of bytes (string) corresponding to the WebP
+ * encoded image and generates output in the YUV format with
+ * the color components U, V subsampled to 1/2 resolution along
+ * each dimension.
+ * Input:
+ *      1. data: the WebP data stream (array of bytes)
+ *      2. data_size: count of bytes in the WebP data stream
+ *
+ * Output:
+ *      3. p_Y/p_U/p_V : pointer to the Y/U/V data buffer (this routine will
+ *                       allocate memory for the buffer, fill the buffer with
+ *                       appropriate data and transfer owner ship of the buffer
+ *                       to caller. Caller is reponsible for freeing the memory).
+ *                       Note that the memory for Y, U, V buffers is alloacted
+ *                       in one chunk, hence one should call free(*p_Y) only.
+ *                       Do not try to free the U and V buffers.
+ *
+ *      6. p_width: this routine returns the width of the decoded image here
+ *      7. p_height: this routine returns the width of the decoded image here
+ * Return: success/failure
+ */
+WebPResult WebPDecode(const uint8* data,
+                      int data_size,
+                      uint8** p_Y,
+                      uint8** p_U,
+                      uint8** p_V,
+                      int* p_width,
+                      int* p_height);
+
+/* WebPEncode: Takes a Y, U, V data buffers (with color components U and V
+ *             subsampled to 1/2 resolution) and generates the WebP string.
+ * Input:
+ *      1, 2, 3. Y, U, V: The input YUV data buffers
+ *      4, 5. y_width, y_height: The width and height of the image whose data
+ *                               is in Y, U, V. This matches the Y plane. The U
+ *                               and V planes typically have 1/2 width and
+ *                               height.
+ *      6. y_stride: The width (in bytes) of one row of Y data. This may not
+ *                   match width if there is end of row padding (e.g., for 32
+ *                   bit row aligment).
+ *      7. QP: the quantization parameter. This parameter controls the
+ *             compression vs quality tradeoff. Use smaller numbers for better
+ *             quality (compression will be lesser) and vice versa. 20 is a
+ *             good optimal value.
+ * Output:
+ *      8. p_out: the output array of bytes corresponding to the encoded WebP
+ *                image. This routine allocates memory for the buffer, fills it
+ *                with appropriate values and transfers ownership to caller.
+ *                Caller responsible for freeing of memory.
+ * Return: success/failure
+ */
+WebPResult WebPEncode(const uint8* Y,
+                      const uint8* U,
+                      const uint8* V,
+                      int y_width,
+                      int y_height,
+                      int y_stride,
+                      int uv_width,
+                      int uv_height,
+                      int uv_stride,
+                      int QP,
+                      unsigned char** p_out,
+                      int* p_out_size_bytes,
+                      double* psnr);
+
+/* Converts from YUV (with color subsampling) such as produced by the WebPDecode
+ * routine into 32 bits per pixel RGBA data array. This data array can be
+ * directly used by the Leptonica Pix in-memory image format.
+ * Input:
+ *      1, 2, 3. Y, U, V: the input data buffers
+ *      4. pixwpl: the desired words per line corresponding to the supplied
+ *                 output pixdata.
+ *      5. width, height: the dimensions of the image whose data resides in Y,
+ *                        U, V.
+ * Output:
+ *     6. pixdata: the output data buffer. Caller should allocate
+ *                 height * pixwpl bytes of memory before calling this routine.
+ */
+void YUV420toRGBA(uint8* Y,
+                  uint8* U,
+                  uint8* V,
+                  int words_per_line,
+                  int width,
+                  int height,
+                  uint32* pixdata);
+
+/* Generates Y, U, V data (with color subsampling) from 32 bits
+ * per pixel RGBA data buffer. The resulting YUV data can be directly fed into
+ * the WebPEncode routine.
+ * Input:
+ *    1. pix data input rgba data buffer
+ *    2. words per line corresponding to pixdata
+ *    3, 4. image width and height respectively
+ * Output:
+ *    5, 6, 7. Output YUV data buffers
+ */
+void RGBAToYUV420(uint32* pixdata,
+                  int words_per_line,
+                  int width,
+                  int height,
+                  uint8* Y,
+                  uint8* U,
+                  uint8* V);
+
+/* This function adjust from YUV420J (jpeg decoding) to YUV420 (webp input)
+ * Hints: http://en.wikipedia.org/wiki/YCbCr
+ */
+void AdjustColorspace(uint8* Y, uint8* U, uint8* V, int width, int height);
+
+/* Inverse function: convert from YUV420 to YUV420J */
+void AdjustColorspaceBack(uint8* Y, uint8* U, uint8* V, int width, int height);
+
+/* Checks WebP image header and outputs height and width information of
+ * the image
+ *
+ * Input:
+ *      1. data: the WebP data stream (array of bytes)
+ *      2. data_size: count of bytes in the WebP data stream
+ *
+ * Outut:
+ *      width/height: width and height of the image
+ *
+ * Return: success/failure
+ */
+WebPResult WebPGetInfo(const uint8* data,
+                       int data_size,
+                       int *width,
+                       int *height);
+
+#ifdef __cplusplus
+}
+#endif  /* __cplusplus */
+
+#endif  /* THIRD_PARTY_VP8_VP8IMG_H_ */
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/webpio.c leptonlib-1.066/src/webpio.c
--- leptonlib-1.66/src/webpio.c	1970-01-01 02:00:00.000000000 +0200
+++ leptonlib-1.066/src/webpio.c	2010-09-29 21:19:39.000000000 +0300
@@ -0,0 +1,397 @@
+/*====================================================================*
+ -  Copyright (C) 2001 Leptonica.  All rights reserved.
+ -  This software is distributed in the hope that it will be
+ -  useful, but with NO WARRANTY OF ANY KIND.
+ -  No author or distributor accepts responsibility to anyone for the
+ -  consequences of using this software, or for whether it serves any
+ -  particular purpose or works at all, unless he or she says so in
+ -  writing.  Everyone is granted permission to copy, modify and
+ -  redistribute this source code, for commercial or non-commercial
+ -  purposes, with the following restrictions: (1) the origin of this
+ -  source code must not be misrepresented; (2) modified versions must
+ -  be plainly marked as such; and (3) this notice may not be removed
+ -  or altered from any source or modified source distribution.
+ -  Author: krish@google.com (krish Chaudhury)
+ *====================================================================*/
+
+/*
+ *  webpio.c
+ *
+ *    Read WebP from file
+ *          PIX             *pixReadWebP()  [ special top level ]
+ *          PIX             *pixReadStreamWebP()
+ *
+ *    Write WebP to file
+ *          l_int32          pixWriteWebP()  [ special top level ]
+ *          l_int32          pixWriteStreamWebP()
+ *
+ *    Write WebP to file with target psnr
+ *          l_int32          pixWriteWebPwithTargetPSNR
+ *
+ */
+
+#include <math.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "allheaders.h"
+
+#ifdef HAVE_CONFIG_H
+#include "config_auto.h"
+#endif  /* HAVE_CONFIG_H */
+
+/* --------------------------------------------*/
+#if  HAVE_LIBWEBP   /* defined in environ.h */
+/* --------------------------------------------*/
+
+#include "webpimg.h"
+
+/*---------------------------------------------------------------------*
+ *                              Reading WebP                            *
+ *---------------------------------------------------------------------*/
+/*!
+ *  pixReadWebP()
+ *
+ *      Input:  filename corresponding to WebP image
+ *      Return: pix (8 or 32 bpp), or null on error
+ */
+PIX *
+pixReadWebP(const char  *filename)
+{
+FILE  *fp;
+PIX   *pix;
+
+    PROCNAME("pixReadWebP");
+
+    if (!filename)
+        return (PIX *)ERROR_PTR("filename not defined", procName, NULL);
+
+    if ((fp = fopenReadStream(filename)) == NULL)
+        return (PIX *)ERROR_PTR("image file not found", procName, NULL);
+    pix = pixReadStreamWebP(fp);
+    fclose(fp);
+
+    if (!pix)
+        return (PIX *)ERROR_PTR("image not returned", procName, NULL);
+    return pix;
+}
+
+
+/*!
+ *  pixReadStreamWebP()
+ *
+ *      Input:  stream corresponding to WebP image
+ *      Return: pix(8 or 32 bpp), or null on error
+ *
+ *  Notes:
+ *      (1) Use 'free', and not leptonica's 'FREE', for all heap data
+ *          that is returned from the WebP library.
+ */
+PIX *
+pixReadStreamWebP(FILE  *fp)
+{
+l_int32    w, h, wpl, ret, nbytes;
+l_uint8   *filedata;
+l_uint8   *Y = NULL;
+l_uint8   *U = NULL;
+l_uint8   *V = NULL;
+l_uint32  *data;
+PIX       *pix;
+
+    PROCNAME("pixReadStreamWebP");
+
+    if (!fp)
+        return (PIX *)ERROR_PTR("fp not defined", procName, NULL);
+
+        /* Read data from file and decode into Y,U,V arrays */
+    rewind(fp);
+    if ((filedata = arrayReadStream(fp, &nbytes)) == NULL)
+        return (PIX *)ERROR_PTR("filedata not read", procName, NULL);
+    ret = WebPDecode(filedata, nbytes, &Y, &U, &V, &w, &h);
+    FREE(filedata);
+    if (ret != webp_success) {
+        if (Y) free(Y);
+        return (PIX *)ERROR_PTR("WebP decode failed", procName, NULL);
+    }
+
+        /* Write from Y,U,V arrays to pix data */
+    pix = pixCreate(w, h, 32);
+    wpl = pixGetWpl(pix);
+    data = pixGetData(pix);
+    YUV420toRGBA(Y, U, V, wpl, w, h, data);
+
+    if (Y) free(Y);
+    return pix;
+}
+
+/*---------------------------------------------------------------------*
+ *                             Writing WebP                             *
+ *---------------------------------------------------------------------*/
+/*!
+ *  pixWriteWebP()
+ *
+ *      Input:  filename
+ *              pix
+ *              quantparam (quantization parameter), controls quality of
+ *              generated WebP, smaller quantparam == better quality.
+ *              Send -1 to get default value.
+ *      Return: 0 if OK, 1 on error
+ */
+l_int32
+pixWriteWebP(const char  *filename,
+             PIX         *pix,
+             l_int32      quantparam)
+{
+FILE  *fp;
+
+    PROCNAME("pixWriteWebP");
+
+    if (!pix)
+        return ERROR_INT("pix not defined", procName, 1);
+    if (!filename)
+        return ERROR_INT("filename not defined", procName, 1);
+
+    if ((fp = fopen(filename, "wb+")) == NULL)
+        return ERROR_INT("stream not opened", procName, 1);
+
+    if (pixWriteStreamWebP(fp, pix, quantparam) != 0) {
+        fclose(fp);
+        return ERROR_INT("pix not written to stream", procName, 1);
+    }
+
+    fclose(fp);
+    return 0;
+}
+
+
+/*!
+ *  pixWriteStreampWebP()
+ *
+ *      Input:  stream
+ *              pix  (32 bpp)
+ *              quantparam (quantization parameter; use -1 for default)
+ *      Return: 0 if OK, 1 on error
+ *
+ *  Notes:
+ *      (1) The @quantparam controls the quality of the generated WebP;
+ *          a smaller quantparam gives better quality.  The following
+ *          table shows a rough correspondence between @quantparam
+ *          and the jpeg quality parameter:
+ *
+ *              quantparam               jpeg quality
+ *              ----------               ------------
+ *              20                         60
+ *              15                         75
+ *              12                         90
+ */
+l_int32
+pixWriteStreamWebP(FILE    *fp,
+                   PIX     *pixs,
+                   l_int32  quantparam)
+{
+l_int32    w, h, d, wpl, uv_width, uv_height, nbytes, ret;
+l_uint8   *Y = NULL;
+l_uint8   *U = NULL;
+l_uint8   *V = NULL;
+l_uint8   *filedata = NULL;
+l_uint32  *data;
+PIX       *pix = NULL;
+
+    PROCNAME("pixWriteStreamWebP");
+
+    if (!fp)
+        return ERROR_INT("stream not open", procName, 1);
+    if (!pixs)
+        return ERROR_INT("pixs not defined", procName, 1);
+    if (quantparam <= 0) quantparam = 20;
+
+    if ((pix = pixRemoveColormap(pixs, REMOVE_CMAP_TO_FULL_COLOR)) == NULL) {
+        return ERROR_INT("cannot remove color map", procName, 1);
+    }
+    pixGetDimensions(pix, &w, &h, &d);
+    wpl = pixGetWpl(pix);
+    data = pixGetData(pix);
+    if (d != 32 || w <= 0 || h <= 0 || wpl <= 0 || !data) {
+        pixDestroy(&pix);
+        return ERROR_INT("bad or empty input pix", procName, 1);
+    }
+
+        /* Read data into Y,U,V arrays */
+    uv_width = (w + 1) >> 1;
+    uv_height = (h + 1) >> 1;
+    nbytes = w * h + 2 * uv_width * uv_height;
+    if ((Y = (l_uint8 *)CALLOC(nbytes, sizeof(l_uint8))) == NULL) {
+        pixDestroy(&pix);
+        return ERROR_INT("YUV buffer alloc failed", procName, 1);
+    }
+    U = Y + w * h;
+    V = U + uv_width * uv_height;
+    RGBAToYUV420(data, wpl, w, h, Y, U, V);
+
+        /* Encode Y,U,V and write data to file */
+    ret = WebPEncode(Y, U, V, w, h, w, uv_width, uv_height, uv_width,
+                     quantparam, &filedata, &nbytes, NULL);
+    FREE(Y);
+    if (ret != webp_success) {
+        if (filedata) free(filedata);
+        pixDestroy(&pix);
+        return ERROR_INT("WebPEncode failed", procName, 1);
+    }
+
+    rewind(fp);
+    if (fwrite(filedata, 1, nbytes, fp) != nbytes) {
+        pixDestroy(&pix);
+        return ERROR_INT("Write error", procName, 1);
+    }
+    free(filedata);
+    pixDestroy(&pix);
+
+    return 0;
+}
+
+
+/*!
+ *  pixWriteWebPwithTargetPSNR()
+ *
+ *      Input:  filename
+ *              pix  (32 bpp rgb)
+ *              target_psnr (target psnr to control the quality [1 ... 99])
+ *              pqp (<optional return> final qp value used to obtain
+ *                   the target_psnr; can be null)
+ *      Return: 0 if OK, 1 on error
+ *
+ *  Notes:
+ *      (1) The parameter to control quality while encoding WebP is qp.
+ *          This function does a line search over the qp values between
+ *          MIN_QP and MAX_QP to achieve the target PSNR as closely as
+ *          possible.
+ */
+l_int32
+pixWriteWebPwithTargetPSNR(const char  *filename,
+                           PIX         *pixs,
+                           l_float64    target_psnr,
+                           l_int32     *pqp)
+{
+l_uint8   *Y = NULL;
+l_uint8   *U = NULL;
+l_uint8   *V = NULL;
+l_uint8   *filedata = NULL;
+l_uint8   *tmp_filedata = NULL;
+l_int32    MIN_QP = 10;  /* min allowed value of qp */
+l_int32    MAX_QP = 63;  /* max allowed value of qp */
+l_int32    w, h, d, wpl, uv_width, uv_height, nbytes, ret;
+l_int32    qp, delta_qp, qp_test, accept;
+l_int32    tmp_nbytes = 0;
+l_uint32  *data;
+l_float64  psnr, psnr_test;
+FILE      *fp;
+PIX       *pix = NULL;
+
+    PROCNAME("pixWriteWebPwithTargetPSNR");
+
+    if (!filename)
+        return ERROR_INT("filename not defined", procName, 1);
+    if (!pixs)
+        return ERROR_INT("pixs not defined", procName, 1);
+    if (target_psnr <= 0 || target_psnr >= 100)
+        return ERROR_INT("Target psnr out of range", procName, 1);
+
+    if ((pix = pixRemoveColormap(pixs, REMOVE_CMAP_TO_FULL_COLOR)) == NULL) {
+        return ERROR_INT("cannot remove color map", procName, 1);
+    }
+    pixGetDimensions(pix, &w, &h, &d);
+    wpl = pixGetWpl(pix);
+    data = pixGetData(pix);
+    if (d != 32 || w <= 0 || h <= 0 || wpl <= 0 || !data) {
+        pixDestroy(&pix);
+        return ERROR_INT("bad or empty input pix", procName, 1);
+    }
+
+        /* Set the initial value of the QP parameter.  In each iteration
+         * it will then increase or decrease the QP value, based on
+         * whether the achieved psnr is higher or lower than the target_psnr */
+    qp = 30;
+
+        /* Read data into Y,U,V arrays */
+    uv_width = (w + 1) >> 1;
+    uv_height = (h + 1) >> 1;
+    nbytes = w * h + 2 * uv_width * uv_height;
+    if ((Y = (l_uint8 *)CALLOC(nbytes, sizeof(l_uint8))) == NULL) {
+        pixDestroy(&pix);
+        return ERROR_INT("YUV buffer alloc failed", procName, 1);
+    }
+    U = Y + w * h;
+    V = U + uv_width * uv_height;
+    RGBAToYUV420(data, wpl, w, h, Y, U, V);
+
+        /* Encode Y,U,V and write data to file */
+    ret = WebPEncode(Y, U, V, w, h, w, uv_width, uv_height, uv_width, qp,
+                     &filedata, &nbytes, &psnr);
+    if (ret != webp_success) {
+        FREE(Y);
+        if (filedata) free(filedata);
+        pixDestroy(&pix);
+        return ERROR_INT("WebPEncode failed", procName, 1);
+    }
+
+        /* Rationale about the delta_qp being limited: we expect the optimal
+         * qp to be not too far from target qp in practice. So instead of a full
+         * dichotomy for the whole [MIN_QP, MAX_QP] range we cap |delta_qp|
+         * to only explore quickly around the starting value and maximize the
+         * return in investment. */
+    delta_qp = (psnr > target_psnr) ? L_MAX((MAX_QP - qp) / 4, 1) :
+        L_MIN((MIN_QP - qp) / 4, -1);
+
+    while (delta_qp != 0) {
+            /* Advance qp and clip to valid range */
+        qp_test = L_MIN(L_MAX(qp + delta_qp, MIN_QP), MAX_QP);
+            /* Re-adjust delta value after QP-clipping. */
+        delta_qp = qp_test - qp;
+
+        ret = WebPEncode(Y, U, V, w, h, w, uv_width, uv_height, uv_width,
+                         qp_test, &tmp_filedata, &tmp_nbytes, &psnr_test);
+
+        if (ret != webp_success) {
+            FREE(Y);
+            free(filedata);
+            if (tmp_filedata) free(tmp_filedata);
+            pixDestroy(&pix);
+            return ERROR_INT("WebPEncode failed", procName, 1);
+        }
+
+            /* Accept or reject new settings */
+        accept = (psnr_test > target_psnr) ^ (delta_qp < 0);
+        if (accept) {
+            free(filedata);
+            filedata = tmp_filedata;
+            nbytes = tmp_nbytes;
+            qp = qp_test;
+            psnr = psnr_test;
+        }
+        else {
+            delta_qp /= 2;
+            free(tmp_filedata);
+        }
+    }
+    if (pqp) *pqp = qp;
+    FREE(Y);
+
+    if ((fp = fopen(filename, "wb+")) == NULL) {
+        free(filedata);
+        pixDestroy(&pix);
+        return ERROR_INT("stream not opened", procName, 1);
+    }
+    ret = (fwrite(filedata, 1, nbytes, fp) != nbytes);
+    fclose(fp);
+    free(filedata);
+    if (ret) {
+        pixDestroy(&pix);
+        return ERROR_INT("Write error", procName, 1);
+    }
+
+    pixDestroy(&pix);
+    return 0;
+}
+
+/* --------------------------------------------*/
+#endif  /* HAVE_LIBWEBP */
+/* --------------------------------------------*/
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/webpiostub.c leptonlib-1.066/src/webpiostub.c
--- leptonlib-1.66/src/webpiostub.c	1970-01-01 02:00:00.000000000 +0200
+++ leptonlib-1.066/src/webpiostub.c	2010-09-24 07:27:09.000000000 +0300
@@ -0,0 +1,61 @@
+/*====================================================================*
+ -  Copyright (C) 2001 Leptonica.  All rights reserved.
+ -  This software is distributed in the hope that it will be
+ -  useful, but with NO WARRANTY OF ANY KIND.
+ -  No author or distributor accepts responsibility to anyone for the
+ -  consequences of using this software, or for whether it serves any
+ -  particular purpose or works at all, unless he or she says so in
+ -  writing.  Everyone is granted permission to copy, modify and
+ -  redistribute this source code, for commercial or non-commercial
+ -  purposes, with the following restrictions: (1) the origin of this
+ -  source code must not be misrepresented; (2) modified versions must
+ -  be plainly marked as such; and (3) this notice may not be removed
+ -  or altered from any source or modified source distribution.
+ *====================================================================*/
+
+/*
+ *  webpiostub.c
+ *
+ *     Stubs for vp8io.c functions
+ */
+
+#include <stdio.h>
+#include "allheaders.h"
+
+#ifdef HAVE_CONFIG_H
+#include "config_auto.h"
+#endif  /* HAVE_CONFIG_H */
+
+/* --------------------------------------------*/
+#if  !HAVE_LIBWEBP   /* defined in environ.h */
+/* --------------------------------------------*/
+
+PIX * pixReadWebP(const char *filename)
+{
+    return (PIX * )ERROR_PTR("function not present", "pixReadWebP", NULL);
+}
+
+PIX * pixReadStreamWebP(FILE *fp)
+{
+    return (PIX * )ERROR_PTR("function not present", "pixReadStreamWebP", NULL);
+}
+
+l_int32 pixWriteWebP(const char *filename, PIX *pix, l_int32 quantparam)
+{
+    return ERROR_INT("function not present", "pixWriteWebP", 1);
+}
+
+l_int32 pixWriteStreamWebP(FILE *fp, PIX *pix, l_int32 quantparam)
+{
+    return ERROR_INT("function not present", "pixWriteStreamWebP", 1);
+}
+
+l_int32 pixWriteWebPwithTargetPSNR(const char *filename, PIX *pix,
+                                  l_float64 target_psnr, l_int32 *qp_ptr)
+{
+    return ERROR_INT("function not present", "pixWriteWebPwithTargetPSNR", 1);
+}
+
+/* --------------------------------------------*/
+#endif  /* !HAVE_LIBWEBP */
+/* --------------------------------------------*/
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/writefile.c leptonlib-1.066/src/writefile.c
--- leptonlib-1.66/src/writefile.c	2010-08-02 08:37:19.000000000 +0300
+++ leptonlib-1.066/src/writefile.c	2010-09-16 08:21:11.000000000 +0300
@@ -55,10 +55,6 @@
 #define  WRITE_AS_NAMED    1
     /* ----------------------------------------------------------- */
 
-#ifdef _WIN32
-#define MAX_PATH     260  /* actually in <WinDef.h>; brings in other files */
-#endif  /* _WIN32 */
-
     /* MS VC++ can't handle array initialization with static consts ! */
 #define L_BUF_SIZE   512
 
@@ -687,13 +683,13 @@
 char           *tempname;
 char            buffer[L_BUF_SIZE];
 static l_int32  index = 0;  /* caution: not .so or thread safe */
-l_int32         w, h, d;
+l_int32         w, h, d, ignore;
 l_float32       ratw, rath, ratmin;
 PIX            *pixt;
 #ifndef _WIN32
 l_int32         wt, ht;
 #else
-char            pathname[MAX_PATH];
+char            pathname[_MAX_PATH];
 #endif  /* _WIN32 */
 
     PROCNAME("pixDisplayWithTitle");
@@ -734,7 +730,7 @@
 
     if (index == 0) {
         snprintf(buffer, L_BUF_SIZE, "rm -f /tmp/junk_display.*");
-        system(buffer);
+        ignore = system(buffer);
     }
 
     index++;
@@ -777,7 +773,7 @@
                  "xzgv --geometry %dx%d+%d+%d %s &", wt + 10, ht + 10,
                  x, y, tempname);
     }
-    system(buffer);
+    ignore = system(buffer);
 
 #else  /* _WIN32 */
 
@@ -790,7 +786,7 @@
     else
         snprintf(buffer, L_BUF_SIZE, "i_view32.exe \"%s\" /pos=(%d,%d)",
                  pathname, x, y);
-    system(buffer);
+    ignore = system(buffer);
 
 #endif  /* _WIN32 */
 
@@ -815,10 +811,11 @@
 l_int32
 pixDisplayMultiple(const char  *filepattern)
 {
-char   buffer[L_BUF_SIZE];
+char     buffer[L_BUF_SIZE];
+l_int32  ignore;
 #ifdef _WIN32
-char   pathname[MAX_PATH];
-char  *dir, *tail;
+char     pathname[_MAX_PATH];
+char    *dir, *tail;
 #endif  /* _WIN32 */
 
     PROCNAME("pixDisplayMultiple");
@@ -839,7 +836,7 @@
     FREE(tail);
 #endif  /* _WIN32 */
 
-    system(buffer);
+    ignore = system(buffer);
     return 0;
 }
 
@@ -903,6 +900,7 @@
                       l_int32  format)
 {
 char            buffer[L_BUF_SIZE];
+l_int32         ignore;
 l_float32       scale;
 PIX            *pixt, *pix8;
 static l_int32  index = 0;  /* caution: not .so or thread safe */
@@ -924,7 +922,7 @@
     if (index == 0) {
         snprintf(buffer, L_BUF_SIZE,
            "rm -f /tmp/junk_write_display.*.png /tmp/junk_write_display.*.jpg");
-        system(buffer);
+        ignore = system(buffer);
     }
     index++;
 
